﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using Niqiu.Core.Domain.Common;
using Niqiu.Core.Domain.Questions;
using Niqiu.Core.Domain.Reports;
using Niqiu.Core.Domain.User;
using Niqiu.Core.Helpers;
using Niqiu.Core.Services;
using Niqiu.Core.Services.Firends;
using Niqiu.Core.Services.Messages;
using Niqiu.Core.Services.Payments;
using Niqiu.Core.Services.Questiones;
using Portal.MVC.Attributes;
using Portal.MVC.Models;
using Portal.MVC.Models.Services;
using Portal.MVC.ViewModel;
using Portal.MVC.WXDevice;
using Portal.MVC.WxPayAPI.lib;
using WxPayAPI;

namespace Portal.MVC.Controllers
{
    [UserLastActivityIp]
    [MenuStatistics]
    public class HomeController : BaseController
    {
       // private readonly IQuestionService _questionDbService;
        //private readonly IPaymentService _paymentService;
        private readonly IWorkContext _workContext;
        private readonly ICacheManager _cacheManager;
        private WxDeviceService wxDeviceService = new WxDeviceService();
        public HomeController(ICacheManager cacheManager,IFirendService firendService,IWorkContext workContext)
        {
          //  _questionDbService = questionService;
            _workContext = workContext;
            _cacheManager = cacheManager;
        }

        private QuestionDbService _questionDbService= new QuestionDbService();
        private PayMeentDbService _payMeentDbService=new PayMeentDbService();
        private UserDbService _userDbService=new UserDbService();
        private FriendDbService _friendDbService=new FriendDbService();
        public ActionResult Index()
        {
            return View();
        }

       )
        {
            var token = getToken();
            var toUserId = "oBSBmwQjqwjfzQlKsFNjxFLSiIQM";
           // var toUserId = "oBSBmwY3vy3B17GzRPgzyVOj4oic";
            var data = new TemplateModel("你好，stoneniqiu","审核通过","资料完整","祝你生活幸福！");
            data.touser = toUserId;
            data.template_id = "gXmkeL7Kc-KUy2EQzKqjPKY-kzFyatTztiYFKCaUPO4";
            data.url = "http://www.haoyoucai888.com//Home/saylove";
            data.topcolor = "#FF0000";

            var res=wxDeviceService.SendTemplateMessage(token, data);
            return View(res);
        }

        public ActionResult SayLove()
        {
            return View();
        }

        private string ticketKey = "jsapi_ticket";
        public string GetTicket()
        {
            var cticket = getCacheTicket();
            var token = getToken();
            if (string.IsNullOrEmpty(cticket))
            {
                cticket = wxDeviceService.GetJsApiTicket(token).ticket;
                setCacheTicket(ticketKey);
            }

            return cticket;
        }
        private string getCacheTicket()
        {
            return _cacheManager.Get<string>(ticketKey);
        }
        private void setCacheTicket(string cache)
        {
            _cacheManager.Set(ticketKey, cache, 7000);
        }
        private string getToken()
        {
            var token = getcacheToken();
            if (token == null || string.IsNullOrEmpty(token.access_token))//|| checkExpire(token.expires_in)
            {
                token = wxDeviceService.GetAccessToken();
                setToken(token);
            }
            return token.access_token;
        }

        private string tokenKey = "access_token";
        private void setToken(TokenResult token)
        {
            _cacheManager.Set(tokenKey, token, 7000);
        }

        private TokenResult getcacheToken()
        {
            return _cacheManager.Get<TokenResult>(tokenKey);
        }
     
    }
}
